namespace Bonosoft.BonosoftLink {
    using System;
    using System.Collections;
    using System.Data;
    using System.Drawing;
    using System.Web;
    using System.Web.UI.WebControls;
    using System.Web.UI.HtmlControls;
    using DotNetNuke.Common;
    using DotNetNuke.Services.Localization;

    public class BonosoftLinkEdit : DotNetNuke.Entities.Modules.PortalModuleBase {
        #region Controls
        protected System.Web.UI.WebControls.TextBox txtTitle;
        protected System.Web.UI.WebControls.RequiredFieldValidator valTitle;
        
        protected DotNetNuke.UI.UserControls.UrlControl ctlURL;
        protected DotNetNuke.UI.UserControls.UrlControl ctlImageURL;

        protected System.Web.UI.WebControls.TextBox txtDescription;

        protected System.Web.UI.WebControls.TextBox txtViewOrder;
        protected System.Web.UI.WebControls.RegularExpressionValidator valViewOrder;

        protected System.Web.UI.WebControls.LinkButton cmdUpdate;
        protected System.Web.UI.WebControls.LinkButton cmdCancel;
        protected System.Web.UI.WebControls.LinkButton cmdDelete;

        protected DotNetNuke.UI.UserControls.URLTrackingControl ctlTracking;

        #endregion
        
        #region Private Members
        private int itemId = -1;
        #endregion


        private void Page_Load(object sender, System.EventArgs e) {
            if (Request.Params["ItemId"]!=null) {
                itemId = Int32.Parse(Request.Params["ItemId"]);
            }
            if (!Page.IsPostBack) {
                cmdDelete.Attributes.Add("onClick", "javascript:return confirm('"+Localization.GetString("DeleteItem")+"');");
				if (itemId != -1) {
                    BonosoftLinkController linkCtrl = new BonosoftLinkController();
                    BonosoftLinkInfo linkInfo = linkCtrl.Get(itemId);

                    if (linkInfo!=null) {
                        if (linkInfo.ModuleID==ModuleId) {

                            txtTitle.Text = linkInfo.Title;
                            txtDescription.Text = linkInfo.Description;
                            if (!DotNetNuke.Common.Utilities.Null.IsNull(linkInfo.ViewOrder)) {
                                txtViewOrder.Text = linkInfo.ViewOrder.ToString();
                            }

							ctlTracking.URL = linkInfo.Url;
							ctlTracking.ModuleID = ModuleId;
							
							DotNetNuke.Services.FileSystem.FileController fileCtrl = new DotNetNuke.Services.FileSystem.FileController();

							String linkURL = linkInfo.Url;
							if (linkURL.ToLower().StartsWith("fileid=")) {
								DotNetNuke.Services.FileSystem.FileInfo fileInfo = fileCtrl.GetFileById(Int32.Parse(linkURL.Substring(7)),PortalId);
								linkURL = fileInfo.Folder+fileInfo.FileName;
							}
							ctlURL.Url = linkURL;

							String imageURL = linkInfo.ImageURL;
							if (imageURL.ToLower().StartsWith("fileid=")) {
								DotNetNuke.Services.FileSystem.FileInfo fileInfo = fileCtrl.GetFileById(Int32.Parse(imageURL.Substring(7)),PortalId);
								imageURL = fileInfo.Folder+fileInfo.FileName;
							}
							ctlImageURL.Url = imageURL;
							ctlImageURL.FileFilter = Globals.glbImageFileTypes;


                        } else { // security violation attempt to access item not related to this Module
                            Response.Redirect(Globals.NavigateURL(), true);
                        }
                    } else {
                        Response.Redirect(Globals.NavigateURL(), true);
                    }
                } else {
                    cmdDelete.Visible = false;
                    ctlTracking.Visible = false;
					ctlImageURL.FileFilter = Globals.glbImageFileTypes;
                }
            }
        }

        private void cmdCancel_Click(object sender, System.EventArgs e) {
            Response.Redirect(Globals.NavigateURL(), true);
        }

        private void cmdDelete_Click(object sender, System.EventArgs e) {
            if (itemId != -1) {
                BonosoftLinkController linkCtrl = new BonosoftLinkController();
                linkCtrl.Delete(itemId);
            }
            Response.Redirect(Globals.NavigateURL(), true);
        }


        private void cmdUpdate_Click(object sender, System.EventArgs e) {
            if (Page.IsValid && ctlURL.Url!="") {
                // Create an instance of the Link DB component
                BonosoftLinkController linkCtrl = new BonosoftLinkController();
                BonosoftLinkInfo linkInfo = null;
                
                if (itemId!=-1) {
                    linkInfo = linkCtrl.Get(itemId);
                }
                if (linkInfo==null) linkInfo = new BonosoftLinkInfo();
                
                linkInfo.ItemID = itemId;
                linkInfo.ModuleID = ModuleId;
                linkInfo.Title = txtTitle.Text;
                linkInfo.Url = ctlURL.Url;
                linkInfo.ImageURL = ctlImageURL.Url;
                linkInfo.MobileUrl = DotNetNuke.Common.Utilities.Null.NullString;
                if (txtViewOrder.Text.Length>0) {
                    linkInfo.ViewOrder = Convert.ToInt32(txtViewOrder.Text);
                }
                linkInfo.Description = txtDescription.Text;
                //                linkInfo.NewWindow = chkNewWindow.Checked;
                
                if (itemId == -1) {
                    linkCtrl.Add(linkInfo);
                } else {
                    linkCtrl.Update(linkInfo);
                }

                // Url tracking
                DotNetNuke.Common.Utilities.UrlController urlCtrl = new DotNetNuke.Common.Utilities.UrlController();
                urlCtrl.UpdateUrl(PortalId, ctlURL.Url, ctlURL.UrlType, ctlURL.Log, ctlURL.Track, ModuleId, ctlURL.NewWindow);

                Response.Redirect(Globals.NavigateURL(), true);
            }
        }

       
        #region Web Form Designer generated code
        override protected void OnInit(EventArgs e) {
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit(e);
        }
		
        /// <summary>
        ///		Required method for Designer support - do not modify
        ///		the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent() {
            this.cmdUpdate.Click += new System.EventHandler(this.cmdUpdate_Click);
            this.cmdCancel.Click += new System.EventHandler(this.cmdCancel_Click);
            this.cmdDelete.Click += new System.EventHandler(this.cmdDelete_Click);
            this.Load += new System.EventHandler(this.Page_Load);

        }
        #endregion
    }
}
