using System;
using System.Collections;
using System.Text;
using System.Xml;
using System.Web;
using DotNetNuke.Common;
using DotNetNuke.Common.Utilities;
using DotNetNuke.Entities.Modules;
using DotNetNuke.Services.Search;

namespace Bonosoft.BonosoftLink {

	public class BonosoftLinkSearch : IPortable, ISearchable {

		public string ExportModule(Int32 moduleID) {
			StringBuilder strXML = new StringBuilder();

			BonosoftLinkController linkCtrl = new BonosoftLinkController();
			ArrayList linkList = linkCtrl.GetByModules(moduleID);
			if (linkList!=null) {
				strXML.Append("<bonosoftlinks>");
				foreach (BonosoftLinkInfo linkInfo in linkList) {
					strXML.Append("<link>");
					strXML.Append("<imageurl>").Append(Globals.XMLEncode(linkInfo.ImageURL)).Append("</imageurl>");
					strXML.Append("<title>").Append(Globals.XMLEncode(linkInfo.Title)).Append("</title>");
					strXML.Append("<url>").Append(Globals.XMLEncode(linkInfo.Url)).Append("</url>");
					strXML.Append("<description>").Append(Globals.XMLEncode(linkInfo.Description)).Append("</description>");
					strXML.Append("<vieworder>").Append(Globals.XMLEncode(linkInfo.ViewOrder.ToString())).Append("</vieworder>");
					strXML.Append("</link>");
				}
				strXML.Append("</bonosoftlinks>");
			}
			return strXML.ToString();
		}

		public void ImportModule(Int32 moduleID, string content, string version, Int32 userId) {
			BonosoftLinkController linkCtrl = new BonosoftLinkController();
			XmlNode xmlPages = Globals.GetContent(content,"bonosoftlinks");
			foreach(XmlNode xmlPage in xmlPages.SelectNodes("link")) {
				BonosoftLinkInfo linkInfo = new BonosoftLinkInfo();				
				linkInfo.ModuleID = moduleID;
				linkInfo.ImageURL = xmlPage["imageurl"].InnerText;
				linkInfo.Title = xmlPage["title"].InnerText;
				linkInfo.Url = xmlPage["url"].InnerText;
				linkInfo.Description = xmlPage["description"].InnerText;
				linkInfo.ViewOrder = Int32.Parse(xmlPage["vieworder"].InnerText);
				linkCtrl.Add(linkInfo);
			}
		}

		public SearchItemInfoCollection GetSearchItems(ModuleInfo modInfo) {
			SearchItemInfoCollection searchItemCollection = new SearchItemInfoCollection();

			BonosoftLinkController linkCtrl = new BonosoftLinkController();
			ArrayList linkList = linkCtrl.GetByModules(modInfo.ModuleID);
			if (linkList!=null) {
				foreach (BonosoftLinkInfo linkInfo in linkList) {
					string linkTitle = HttpUtility.HtmlDecode(linkInfo.Title);
					string linkDesc = HtmlUtils.Shorten(HtmlUtils.Clean(linkInfo.Description, false), 100 , "...");
					searchItemCollection.Add(new SearchItemInfo(modInfo.ModuleTitle,linkDesc,0,DateTime.Today,modInfo.ModuleID,linkInfo.ItemID.ToString(),linkTitle,null));
				}
			}
			return searchItemCollection;
		}
	}
}
