namespace Bonosoft.BonosoftLink {
    using System;
	using System.IO;
	using System.Collections;
    using System.Data;
    using System.Drawing;
    using System.Text;
    using System.Web;
    using System.Web.UI.WebControls;
    using System.Web.UI.HtmlControls;
    using DotNetNuke.Entities.Modules;
    using DotNetNuke.Entities.Modules.Actions;
    using DotNetNuke.Services.Localization;
	using DotNetNuke.Services.Search;

    /// <summary>
    ///		Summary description for ViewLink.
    /// </summary>
    public class BonosoftLinkView : PortalModuleBase, IActionable, IPortable, ISearchable {
        protected System.Web.UI.WebControls.ImageButton cmdEdit;
        protected System.Web.UI.WebControls.DropDownList cboLinks;
        protected System.Web.UI.WebControls.LinkButton cmdGo;
        protected System.Web.UI.WebControls.Panel pnlDropdown;

        protected string listString = "";

        private void Page_Load(object sender, System.EventArgs e) {
			// Check for upgrade
			bool mustUpgrade = false;
			if (!Settings.ContainsKey("BSLinkVersion")) {
				mustUpgrade = true;
			} else {
				// In the future we need to look at the version saved.
			}
			if (mustUpgrade) {
				String modulePath = MapPath(this.TemplateSourceDirectory);
				if (!modulePath.EndsWith(Path.DirectorySeparatorChar.ToString())) modulePath += Path.DirectorySeparatorChar;
				if (File.Exists(modulePath+"ViewLink.ascx")) File.Delete(modulePath+"ViewLink.ascx");
				if (File.Exists(modulePath+"EditLink.ascx")) File.Delete(modulePath+"EditLink.ascx");
				if (File.Exists(modulePath+"SettingLink.ascx")) File.Delete(modulePath+"SettingLink.ascx");
				String binPath = MapPath("~/bin/");
				if (!binPath.EndsWith(Path.DirectorySeparatorChar.ToString())) binPath += Path.DirectorySeparatorChar;
				if (File.Exists(binPath+"bonosoft.dnn.modules.link.dll")) File.Delete(binPath+"bonosoft.dnn.modules.link.dll");
				if (File.Exists(binPath+"bonosoft.dnn.modules.link.accessdataprovider.dll")) File.Delete(binPath+"bonosoft.dnn.modules.link.accessdataprovider.dll");
				if (File.Exists(binPath+"bonosoft.dnn.modules.link.sqldataprovider.dll")) File.Delete(binPath+"bonosoft.dnn.modules.link.sqldataprovider.dll");
				ModuleController moduleCtrl = new ModuleController(); 
				moduleCtrl.UpdateModuleSetting(ModuleId, "BSLinkVersion", "3.0.0");
			}

			
			DotNetNuke.Services.FileSystem.FileController fileCtrl = new DotNetNuke.Services.FileSystem.FileController();
			DotNetNuke.Common.Utilities.UrlController urlCtrl = new DotNetNuke.Common.Utilities.UrlController();
			BonosoftLinkController blController = new BonosoftLinkController();
            LinkSetting linkSetting = new LinkSetting(this.Settings);
            if (linkSetting.AsLink) {
                String rootPath = ((Request.ApplicationPath == "/") ? Request.ApplicationPath : Request.ApplicationPath + "/");
                int itemCount = 0;
                StringBuilder listStr = new StringBuilder();
                listStr.Append("\r\n<table border=0 cellspacing=5 cellpadding=0>\r\n");
                ArrayList linkList = blController.GetByModules(ModuleId);
                if (linkSetting.IsHorizontal) {
                    listStr.Append("<tr>");
                }
                int maxShowCount=Int32.MaxValue;
                ArrayList showList = new ArrayList(linkList);
                if (linkSetting.MaxShowCount>0) {
                    if (!IsEditable) {
                        Random rnd = new Random();
                        maxShowCount=linkSetting.MaxShowCount;
                        while (showList.Count>maxShowCount) {
                            showList.RemoveAt(rnd.Next(showList.Count));
                        }
                    }
                }
                foreach(BonosoftLinkInfo linkInfo in showList) {
                    if (!linkSetting.IsHorizontal) {
                        listStr.Append(" <tr>");
                    }
                    string linkStr = linkInfo.Url;
					DotNetNuke.Common.Utilities.UrlTrackingInfo trackInfo = urlCtrl.GetUrlTracking(PortalId,linkStr,ModuleId);
                    if (linkStr==null) linkStr="";
                    if (linkStr.IndexOf("://")<0) {
                        if (IsNumeric(linkStr)) {
                            linkStr = rootPath + "DesktopDefault.aspx?tabid=" + linkStr;                    
                        } else {
							if (linkStr.ToLower().StartsWith("fileid=")) {
								DotNetNuke.Services.FileSystem.FileInfo fileInfo = fileCtrl.GetFileById(Int32.Parse(linkStr.Substring(7)),PortalId);
								linkStr = this.PortalSettings.HomeDirectory + fileInfo.Folder+fileInfo.FileName;
							} else {
								linkStr = this.PortalSettings.HomeDirectory + linkStr;
							}
                        }
                    } 
					if (trackInfo!=null) {
						linkStr = DotNetNuke.Common.Globals.LinkClick(linkStr, TabId, ModuleId, trackInfo.TrackClicks);
					}
                    string targetStr = "";
                    if (trackInfo!=null && trackInfo.NewWindow) {
                        targetStr = " target=\"_new\"";
                    }
                    if (IsEditable) {
                        listStr.Append("<td><a href=\""+EditUrl("ItemID",linkInfo.ItemID.ToString())+"\"><img src=\""+rootPath+"images/edit.gif\" border=0></a>&nbsp;</td>");
                    }
                    string altStr = "";
                    if ((linkInfo.Description!=null) && (linkInfo.Description.Length>0)) {
                        altStr = " title=\""+linkInfo.Description+"\"";
                    }
                    if ((linkInfo.ImageURL!=null) && (linkInfo.ImageURL.Length>0)) {
                        if (linkInfo.ImageURL.IndexOf("://")>0) {
                            listStr.Append("<td valign=top><a href=\""+linkStr+"\""+targetStr+altStr+"><img src=\""+linkInfo.ImageURL+"\" border=0></a></td>");
                        } else {
                            if (linkInfo.ImageURL.ToLower().StartsWith("fileid=")) {
                                DotNetNuke.Services.FileSystem.FileInfo fileInfo = fileCtrl.GetFileById(Int32.Parse(linkInfo.ImageURL.Substring(7)),PortalId);
                                listStr.Append("<td valign=top><a href=\""+linkStr+"\""+targetStr+altStr+"><img src=\""+this.PortalSettings.HomeDirectory+fileInfo.Folder+fileInfo.FileName+"\" border=0></a></td>");
                            } else {
                                listStr.Append("<td valign=top><a href=\""+linkStr+"\""+targetStr+altStr+"><img src=\""+this.PortalSettings.HomeDirectory+linkInfo.ImageURL+"\" border=0></a></td>");
                            }
                        }
                    } else {
                        listStr.Append("<td></td>");
                    }
                    listStr.Append("<td valign=top class=\"Normal\"><a href=\""+linkStr+"\""+targetStr+altStr+"><font color=\""+linkSetting.HeaderColor+"\">"+linkInfo.Title+"</font></a>");
                    if ((linkSetting.ExpandAll) && (linkInfo.Description!=null) && (linkInfo.Description.Length>0)) {
                        listStr.Append("<br><font color=\""+linkSetting.TextColor+"\">"+linkInfo.Description+"</font>");
                    }
                    listStr.Append("</td>");
                    if (linkSetting.IsHorizontal) {
                        listStr.Append("<td>&nbsp;</td>\r\n");
                    } else {
                        listStr.Append("</tr>\r\n");
                    }
                    itemCount++;
                }
                if (linkSetting.IsHorizontal) {
                    listStr.Append("</tr>");
                }
                listStr.Append("</table>\r\n");
                if (itemCount>0) {
                    listString = listStr.ToString();
                }
            }
            if (!Page.IsPostBack) {
                if (!linkSetting.AsLink) {
                    pnlDropdown.Visible = true;
                    cmdEdit.Visible = this.IsEditable;
                    cmdGo.ToolTip = "Go";
                    cboLinks.DataSource = blController.GetByModules(ModuleId);
                    cboLinks.DataBind();
                }
            }
        }

        //        private string editURL(string keyStr, string valueStr) {
        //            string relPath = this.editURL(keyStr,valueStr,"Edit");
        //            if ((relPath!=null) && (relPath.IndexOf('~')>=0)) {
        //                String rootPath = ((Request.ApplicationPath == "/") ? "" : Request.ApplicationPath);
        //                relPath = relPath.Replace("~",rootPath);
        //            }
        //            return relPath;
        //        }

        public static bool IsNumeric(object value) { 
            try { 
                double d = System.Double.Parse(value.ToString(), System.Globalization.NumberStyles.Any); 
                return true; 
            } 
            catch (FormatException) { 
                return false; 
            } 
        }

        protected void cmdEdit_Click(object sender, System.Web.UI.ImageClickEventArgs e) {
            //            Response.Redirect(editURL("ItemID", cboLinks.SelectedItem.Value,"Edit"), true);
        }

        private void cmdGo_Click(object sender, System.EventArgs e) {
            string strURL = "";
            BonosoftLinkController linkCtrl = new BonosoftLinkController();
            BonosoftLinkInfo linkInfo = linkCtrl.Get(Int32.Parse(cboLinks.SelectedItem.Value));
            if (linkInfo!=null) {
                strURL = FormatURL(linkInfo.Url, Int32.Parse(cboLinks.SelectedItem.Value));
            }            
            Response.Redirect(strURL, true);
        }


        public string FormatURL(string linkStr, int ID) {
            String rootPath = ((Request.ApplicationPath == "/") ? Request.ApplicationPath : Request.ApplicationPath + "/");
            if (linkStr.IndexOf("://")<0) {
                if (IsNumeric(linkStr)) {                    
                    linkStr = rootPath + "DesktopDefault.aspx?tabid=" + linkStr;                    
                } else {
                    linkStr = PortalSettings.HomeDirectory + linkStr;
                }
            } else {
                LinkSetting linkSetting = new LinkSetting(this.Settings);
                if (linkSetting.UseLinkClick) {
                    linkStr = rootPath + "admin/Portal/LinkClick.aspx?tabid=" + TabId + "&table=BonosoftLink&field=ItemID&id=" + ID.ToString() + "&link=" + Server.UrlEncode(linkStr);
                }
            }
            return linkStr;
        }

		#region Optional Interfaces

        public DotNetNuke.Entities.Modules.Actions.ModuleActionCollection ModuleActions {
            get { 
                ModuleActionCollection actions = new ModuleActionCollection();
                actions.Add(GetNextActionID(),Localization.GetString(ModuleActionType.AddContent, LocalResourceFile), ModuleActionType.AddContent, "", "", EditUrl(), false, DotNetNuke.Security.SecurityAccessLevel.Edit, true, false);
                return actions; 
            }
        }

		public string ExportModule(Int32 moduleID) {
			return null;
		}

		public void ImportModule(Int32 moduleID, string content, string version, Int32 userId) {
			// dummy to enable import
		}

		public SearchItemInfoCollection GetSearchItems(ModuleInfo modInfo) {
			return null;
		}
		#endregion



        #region Web Form Designer generated code
        override protected void OnInit(EventArgs e) {
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit(e);
        }
		
        /// <summary>
        ///		Required method for Designer support - do not modify
        ///		the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()	{
            this.cmdEdit.Click += new System.Web.UI.ImageClickEventHandler(this.cmdEdit_Click);
            this.cmdGo.Click += new System.EventHandler(this.cmdGo_Click);
            this.Load += new System.EventHandler(this.Page_Load);
        }
        #endregion
    }
}
