using System;
using System.Collections;

namespace Bonosoft.BonosoftLink {

    public class LinkSetting {
        public const string C_LINK_CONTROL = "linkcontrol";        
        public const string C_LINK_VIEW = "linkview";        
        public const string C_EXPAND_ALL = "expandall";        
        public const string C_DISPLAY_INFO = "displayinfo";        
        public const string C_USE_LINK_CLICK = "uselinkclick";
        public const string C_MAX_SHOW_COUNT = "maxshowcount";
        public const string C_HEADER_COLOR = "headercolor";
        public const string C_TEXT_COLOR = "textcolor";

        private bool mAsLinks;
        private bool mIsHorizontal;
        private bool mExpandAll;
        private bool mDisplayInfo;
        private bool mUseLinkClick;
        private int mMaxShowCount;
        private string mHeaderColor;
        private string mTextColor;

        private Hashtable Settings;

        public LinkSetting(Hashtable setting) {
            this.Settings = setting;
            mAsLinks = getStrSetting(C_LINK_CONTROL,"Y")!="N";
            mIsHorizontal = getStrSetting(C_LINK_VIEW,"N")!="N";
            mExpandAll = getStrSetting(C_EXPAND_ALL,"N")!="N";
            mDisplayInfo = getStrSetting(C_DISPLAY_INFO,"N")!="N";
            mUseLinkClick = getStrSetting(C_USE_LINK_CLICK,"N")!="N";
            mMaxShowCount = getIntSetting(C_MAX_SHOW_COUNT,0);
            mHeaderColor = getStrSetting(C_HEADER_COLOR,"#000000");
            mTextColor = getStrSetting(C_TEXT_COLOR,"#000000");
        }

        public void saveContentSetting(int ModuleId) {
            DotNetNuke.Entities.Modules.ModuleController modules = new DotNetNuke.Entities.Modules.ModuleController();
            modules.UpdateModuleSetting(ModuleId, C_LINK_CONTROL, (mAsLinks?"Y":"N"));
            modules.UpdateModuleSetting(ModuleId, C_LINK_VIEW, (mIsHorizontal?"Y":"N"));
            modules.UpdateModuleSetting(ModuleId, C_EXPAND_ALL, (mExpandAll?"Y":"N"));
            modules.UpdateModuleSetting(ModuleId, C_DISPLAY_INFO, (mDisplayInfo?"Y":"N"));
            modules.UpdateModuleSetting(ModuleId, C_USE_LINK_CLICK, (mUseLinkClick?"Y":"N"));
            modules.UpdateModuleSetting(ModuleId, C_MAX_SHOW_COUNT, mMaxShowCount.ToString());
            modules.UpdateModuleSetting(ModuleId, C_HEADER_COLOR, mHeaderColor);
            modules.UpdateModuleSetting(ModuleId, C_TEXT_COLOR, mTextColor);
        }

        public bool AsLink {
            get { return mAsLinks; }
            set { mAsLinks = value; }
        }

        public bool IsHorizontal {
            get { return mIsHorizontal; }
            set { mIsHorizontal = value; }
        }
        public bool ExpandAll {
            get { return mExpandAll; }
            set { mExpandAll = value; }
        }
        public bool DisplayInfo {
            get { return mDisplayInfo; }
            set { mDisplayInfo = value; }
        }
        public bool UseLinkClick {
            get { return mUseLinkClick; }
            set { mUseLinkClick = value; }
        }
        public int MaxShowCount {
            get { return mMaxShowCount; }
            set { mMaxShowCount=value; }
        }
        public string HeaderColor {
            get { return mHeaderColor; }
            set { mHeaderColor=value; }
        }
        public string TextColor {
            get { return mTextColor; }
            set { mTextColor=value; }
        }



        private string getStrSetting(string keyName, string defaultStr) {
            string res = defaultStr;
            if (Settings.Contains(keyName)) {
                res = (string)Settings[keyName];
                if (res==null) res="";
            }
            return res;
        }

        private int getIntSetting(string keyName, int defaultInt) {
            int res = defaultInt;
            if (Settings.Contains(keyName)) {
                try {
                    res = Int32.Parse((string)Settings[keyName]);
                } catch {
                    res = defaultInt;
                }
            }
            return res;
        }

	}
}
